# -*- coding: utf-8 -*-
"""Monthly Customer Patterns.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1nHbrhzgar2a6M1jysGSsmRGR4rWdmdYz
"""


from sqlalchemy import create_engine
import pandas as pd
engine = create_engine("mysql+pymysql://tuadmin:Turant123@turantdb-instance.cdvlyair641e.ap-south-1.rds.amazonaws.com""/turant")
connn = engine.connect()

orders = pd.read_sql("""SELECT * FROM orders where created_on > curdate() - interval 365 day
  """, con=connn)
order_groups = pd.read_sql("""SELECT * FROM order_groups where created_on > curdate() - interval 365 day
  """, con=connn)

orders['yearmonth']=orders['created_on'].dt.to_period('M')

orders['cohort'] = orders.groupby('user_id')['created_on'] \
                 .transform('min') \
                 .dt.to_period('M')

df=orders
from operator import attrgetter
df_cohort = df.groupby(['cohort', 'yearmonth']) \
              .agg(n_customers=('user_id', 'nunique')) \
              .reset_index(drop=False)
df_cohort['period_number'] = (df_cohort.yearmonth - df_cohort.cohort).apply(attrgetter('n'))
cohort_pivot = df_cohort.pivot_table(index = 'cohort',
                                     columns = 'period_number',
                                     values = 'n_customers')
cohort_size = cohort_pivot.iloc[:,0]
retention_matrix = cohort_pivot.divide(cohort_size, axis = 0)

cohort_pivot=cohort_pivot.fillna(0)
cohort_pivot_percentage=cohort_pivot.copy()
months=[0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11]
for i in months:
  cohort_pivot=cohort_pivot.fillna(0)
  cohort_pivot_percentage[i]=cohort_pivot[i]/cohort_pivot[0]*100
cohort_pivot_percentage=cohort_pivot_percentage.head(9)
cohort_pivot_percentage=cohort_pivot_percentage.append(cohort_pivot_percentage.mean(axis=0).T,ignore_index=True)
cohort_pivot_percentage=cohort_pivot_percentage.astype(int)
cohort_pivot_percentage=cohort_pivot_percentage.reset_index()
cohort_pivot_percentage=cohort_pivot_percentage.astype('str')
cohort_pivot_percentage=cohort_pivot_percentage.tail(1)
engine = create_engine("mysql+pymysql://tuadmin:Turant123@turantdb-instance.cdvlyair641e.ap-south-1.rds.amazonaws.com""/turant")
con = engine.connect()

# # # Read
# #Todays_Opportunity = pd.read_sql('select * from Todays_Opportunity;', con=con) 
cohort_pivot_percentage.to_sql(con=con, name='cohort', if_exists='replace',index=False)
con.close()



df=pd.pivot_table(orders,index='yearmonth',values=['user_id','net_total'],aggfunc=['count','sum']).reset_index().reset_index()[[
            ('yearmonth',          ''),
            (    'count', 'net_total'),
            (      'sum', 'net_total')]]
df['avgordermonth']=df[(      'sum', 'net_total')]/df[(    'count', 'net_total')]
df=df[[(    'yearmonth',          ''),
            ('avgordermonth',          '')]]
df.columns=['yearmonth','avgordersize']
df['avgordersize']=df['avgordersize'].astype(int)
df=df.astype('str')
engine = create_engine("mysql+pymysql://tuadmin:Turant123@turantdb-instance.cdvlyair641e.ap-south-1.rds.amazonaws.com""/turant")
con = engine.connect()

# # # Read
# #Todays_Opportunity = pd.read_sql('select * from Todays_Opportunity;', con=con) 
df.to_sql(con=con, name='monthonmonthavgordersize', if_exists='replace',index=False)
con.close()